<template>
    <v-card color="grey lighten-5">
        <v-card-title>
            <v-btn
                @click="clear"
                :disabled="loading"
                color="white"
                small
            >{{ $t('clear') }}</v-btn>
            <v-spacer></v-spacer>
            <v-btn
                :disabled="loading"
                @click="$emit('confirmed')"
                color="primary"
                small
            >{{ $t('confirm') }}</v-btn>
        </v-card-title>
        <v-card-text>
            <v-list>
                <v-list-item>
                    <v-list-item-content>
                        <v-list-item-title class="text-capitalize">{{ $t('price_range') }}</v-list-item-title>
                        <v-range-slider
                            v-model="selectedPriceRange"
                            @change="onPriceRangeChange"
                            :min="0"
                            :max="5000"
                            step="100"
                            thumb-color="primary"
                            thumb-label
                            hide-details
                        ></v-range-slider>
                    </v-list-item-content>
                </v-list-item>
            </v-list>

            <v-divider></v-divider>

            <v-list>
                <v-list-item>
                    <v-list-item-content>
                        <v-col class="d-flex pa-0">
                            <v-switch
                                v-model="selectedMostPopular"
                                @change="onMostPopularChange"
                                class="ml-2 mt-0"
                                :label="$t('most_popular')"
                                :true-value="1"
                                :false-value="0"
                                hide-details
                                dense
                            >
                            </v-switch>
                            <v-switch
                                v-model="selectedNewArrival"
                                @change="onNewArrivalChange"
                                class="ml-2 mt-0"
                                :label="$t('new_arrival')"
                                :true-value="1"
                                :false-value="0"
                                hide-details
                                dense
                            >
                            </v-switch>
                        </v-col>
                    </v-list-item-content>
                </v-list-item>
            </v-list>

            <v-divider></v-divider>

            <v-list>
                <v-list-item>
                    <v-list-item-content>
                        <v-radio-group
                            v-model="selectedStatus"
                            @change="onStatusChange"
                            class="ml-2 mt-0"
                            row
                            dense
                            hide-details
                        >
                            <v-radio
                                :value="1"
                                :label="$t('enabled')"
                                hide-details
                            ></v-radio>
                            <v-radio
                                :value="0"
                                :label="$t('disabled')"
                                hide-details
                            ></v-radio>
                        </v-radio-group>
                    </v-list-item-content>
                </v-list-item>
            </v-list>

            <v-divider></v-divider>

            <v-list>
                <div v-if="loading" class="d-flex justify-center">
                    <v-progress-circular indeterminate color="primary"></v-progress-circular>
                </div>
                <v-list-group
                    v-else
                    v-for="selection in selections"
                    v-model="selection.active"
                    :key="selection.text"
                >
                    <template v-slot:activator>
                        <v-list-item-title>{{ selection.text }}</v-list-item-title>
                    </template>

                    <v-list-item-group
                        v-if="selection.field === 'gender'"
                        v-model="selectedGenders"
                        multiple
                    >
                        <v-list-item
                            v-for="gender in selectableGenders"
                            :key="gender.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ gender.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>

                    <v-list-item-group
                        v-if="selection.field === 'type'"
                        v-model="selectedTypes"
                        multiple
                    >
                        <v-list-item
                            v-for="type in selectableTypes"
                            :key="type.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ type.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>

                    <v-list-item-group
                        v-if="selection.field === 'brand'"
                        v-model="selectedBrands"
                        multiple
                    >
                        <v-list-item
                            v-for="brand in selectableBrands"
                            :key="brand.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ brand.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>

                    <v-list-item-group
                        v-if="selection.field === 'business_type'"
                        v-model="selectedBusinessTypes"
                        multiple
                    >
                        <v-list-item
                            v-for="businessType in selectableBusinessTypes"
                            :key="businessType.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ businessType.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>

                    <v-list-item-group
                        v-if="selection.field === 'category'"
                        v-model="selectedCategories"
                        multiple
                    >
                        <v-list-item
                            v-for="categories in selectableCategories"
                            :key="categories.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ categories.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>

                    <v-list-item-group
                        v-if="selection.field === 'variant'"
                        v-model="selectedVariants"
                        multiple
                    >
                        <v-list-item
                            v-for="variant in selectableVariants"
                            :key="variant.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ variant.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>
                </v-list-group>
            </v-list>
        </v-card-text>
    </v-card>
</template>

<script>
    export default {
        name: 'ProductFilters',
        props: [
            'types',
            'genders',
            'brands',
            'prices',
            'newArrival',
            'mostPopular',
            'variants',
            'categories',
            'businessTypes'
        ],
        data: () => ({
            loading: false,
            selectableGenders: [],
            selectedGenders: [],
            selectableBrands: [],
            selectedBrands:[],
            selectableBusinessTypes: [],
            selectedBusinessTypes:[],
            selectableTypes: [],
            selectedTypes: [],
            selectableCategories: [],
            selectedCategories: [],
            selectableVariants: [],
            selectedVariants: [],
            selectedPriceRange: [0, 9999],
            selectedNewArrival: undefined,
            selectedMostPopular: undefined,
            selectedStatus: undefined,
        }),
        computed: {
            selections() {
                return [
                    {
                        text: this.$tc('brand', 2),
                        field: 'brand',
                        active: false
                    },
                    {
                        text: this.$tc('business_type', 2),
                        field: 'business_type',
                        active: false
                    },
                    {
                        text: this.$tc('collection', 2),
                        field: 'type',
                        active: false
                    },
                    {
                        text: this.$tc('gender', 2),
                        field: 'gender',
                        active: false
                    },
                    {
                        text: this.$tc('variant', 2),
                        field: 'variant',
                        active: false
                    },
                    {
                        text: this.$tc('category', 2),
                        field: 'category',
                        active: false
                    }
                ]
            }
        },
        watch: {
            selectedGenders(ids) {
                const map = ids.map(id => {
                    return this.selectableGenders[id].id
                });
                this.$emit('update:genders', map);
            },

            selectedTypes(ids) {
                const map = ids.map(id => {
                    return this.selectableTypes[id].id
                });
                this.$emit('update:types', map);
            },

            selectedBrands(ids) {
                const map = ids.map(id => {
                    return this.selectableBrands[id].id
                });
                this.$emit('update:brands', map);
            },

            selectedBusinessTypes(ids) {
                const map = ids.map(id => {
                    return this.selectableBusinessTypes[id].id
                });
                this.$emit('update:business_types', map);
            },

            selectedCategories(ids) {
                const map = ids.map(id => {
                    return this.selectableCategories[id].id
                });
                this.$emit('update:categories', map);
            },

            selectedVariants(ids) {
                const map = ids.map(id => {
                    return this.selectableVariants[id].id
                });
                this.$emit('update:variants', map);
            },
        },
        created() {
            this.loading = true;

            axios.get('api/genders')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableGenders = data;
                })
                .catch(error => {
                    this.loading = false;
                })

            axios.get('api/brands')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableBrands = data;
                })
                .catch(error => {
                    this.loading = false;
                })

            axios.get('api/business-types')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableBusinessTypes = data;
                })
                .catch(error => {
                    this.loading = false;
                })

            axios.get('api/categories')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableCategories = data;
                })
                .catch(error => {
                    this.loading = false;
                })

            axios.get('api/products/types')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableTypes = data;
                })
                .catch(error => {
                    this.loading = false;
                })

            axios.get('api/variants/options')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableVariants = data;
                })
                .catch(error => {
                    this.loading = false;
                })
        },
        methods: {
            clear() {
                this.selectedGenders = [];
                this.selectedBrands = [];
                this.selectedBusinessTypes = [];
                this.selectedTypes = [];
                this.selectedCategories = [];
                this.selectedVariants = [];
                this.selectedPriceRange = [0, 9999];
                this.selectedNewArrival = undefined;
                this.selectedMostPopular = undefined;
                this.selectedStatus = undefined;
                this.selections.forEach(selection => {
                    selection.active = false;
                })

                this.$emit('update:prices', this.selectedPriceRange);
                this.$emit('update:most-popular', this.selectedMostPopular);
                this.$emit('update:new-arrival', this.selectedNewArrival);
                this.$emit('update:status', this.selectedStatus);
            },

            onPriceRangeChange(range) {
                this.$emit('update:prices', range);
            },

            onMostPopularChange(popular) {
                this.$emit('update:most-popular', popular);
            },

            onNewArrivalChange(arrival) {
                this.$emit('update:new-arrival', arrival);
            },

            onStatusChange(status) {
                this.$emit('update:status', status);
            }
        }
    }
</script>

<style scoped>
</style>
